From 5ba5086ad58f508c12d4e9cbf7e2c1c3bcb7731b Mon Sep 17 00:00:00 2001
From: Jana Cupova <root@localhost>
Date: Sep 04 2024 07:17:14 +0000
Subject: [PATCH 2/11] Fix review


---

diff --git a/plugins/builder/taskrepos.conf b/plugins/builder/taskrepos.conf
index b75c69b..7769b2f 100644
--- a/plugins/builder/taskrepos.conf
+++ b/plugins/builder/taskrepos.conf
@@ -2,3 +2,27 @@
 # expire_repos = 14
 # ticketlink = 
 # sourcecodelink = https://pagure.io/koji/blob/master/f/plugins/builder/taskrepos.py
+email_template : From: %%(from_addr)s
+    Subject: repo for %%(build)s of %%(nvr)s is available
+    To: %%(recipient)s
+    A yum repository for the %%(build)s of %%(nvr)s (task %%(task_id)s) is available at:
+    %%(repodir)s/
+
+    You can install the rpms locally by putting this .repo file in your /etc/yum.repos.d/ directory:
+    %%(repofile)s
+
+    It is necessary to have internal Red Hat CA certificates installed on the system, if
+    you want to use yum repository. You can install required certificates from:
+    * http://hdn.corp.redhat.com/rhel7-csb-stage/repoview/redhat-internal-cert-install.html (rpm)
+    * https://certs.corp.redhat.com/ (cert files)
+
+    The full list of repos is:
+    %%(repo_urls)s
+
+    The repository will be available for the next %%(repolifetime)s days.
+    Scratch build output will be deleted earlier, based on the Brew scratch build retention policy.
+
+    If you found a bug or you wish to stop these emails, please create a ticket:
+    %%(ticketlink)s
+
+    Source code at %%(sourcecode)s
\ No newline at end of file
diff --git a/plugins/builder/taskrepos.py b/plugins/builder/taskrepos.py
index aabd0bd..6fc99ab 100644
--- a/plugins/builder/taskrepos.py
+++ b/plugins/builder/taskrepos.py
@@ -2,96 +2,65 @@
 
 from __future__ import absolute_import
 
-import datetime
-import fcntl
 import os
 import six
 import smtplib
 import subprocess
 
 import koji
-from koji import request_with_retry
 import koji.tasks
 from koji.tasks import (
     BaseTaskHandler
 )
-from koji.util import (
-    joinpath,
-    rmtree
-)
+from koji.util import joinpath
+
 
-__all__ = ('TaskReposTask',)
+__all__ = ('TaskReposTask', 'tasksRepoNotifications')
 
 CONFIG_FILE = '/etc/kojid/plugins/taskrepos.conf'
+config = None
 
 
-class TaskReposTask(koji.tasks.BaseTaskHandler):
+def read_config():
+    global config
+    cp = koji.read_config_files(CONFIG_FILE)
+    config = {
+        'repo_lifetime': 14,  # days
+        'ticketlink': '',
+        'sourcecode': '',
+        'email_template': '',
+    }
 
-    Methods = ['taskrepos']
-    _taskWeight = 2.0
+    # expire repos in days
+    if cp.has_option('taskrepos', 'expire_repos'):
+        config['repo_lifetime'] = cp.get('taskrepos', 'expire_repos')
 
-    def __init__(self, *args, **kwargs):
-        self._read_config()
-        return super(TaskReposTask, self).__init__(*args, **kwargs)
+    if cp.has_option('taskrepos', 'ticketlink'):
+        config['ticketlink'] = cp.get('taskrepos', 'ticketlink')
 
-    def _read_config(self):
-        cp = koji.read_config_files(CONFIG_FILE)
-        self.config = {
-            'REPO_LIFETIME': 14,  # days
-        }
+    if cp.has_option('taskrepos', 'sourcecodelink'):
+        config['sourcecode'] = cp.get('taskrepos', 'sourcecodelink')
 
-        # expire repos in days
-        if cp.has_option('taskrepos', 'expire_repos'):
-            self.config['REPO_LIFETIME'] = cp.get('taskrepos', 'expire_repos')
-
-    def rm_contents(self, path):
-        with os.scandir(path) as it:
-            for e in it:
-                if e.is_dir(follow_symlinks=False):
-                    rmtree(e.path)
-                else:
-                    os.remove(e.path)
+    if cp.has_option('taskrepos', 'email_template'):
+        config['email_template'] = cp.get('taskrepos', 'email_template')
 
-    def requests_get(self, url, filedest):
-        self.logger.debug(f'Retrieving {url} to {filedest}...')
-        start = datetime.datetime.utcnow()
-        resp = request_with_retry().get(url, stream=True)
-        try:
-            with open(filedest, 'wb') as fo:
-                for chunk in resp.iter_content(chunk_size=1048576):
-                    fo.write(chunk)
-        finally:
-            resp.close()
-        end = datetime.datetime.utcnow()
-        self.logger.debug(f'Received {os.path.getsize(filedest)} bytes in {end - start}')
-
-    def mirror_rpms(self, rpms, content_dir, build=None):
-        remote_pi = koji.PathInfo(topdir=self.options.topurl)
-        for rpm in rpms:
-            if build:
-                # rpm is a dict of rpminfo
-                url = remote_pi.build(build) + '/' + remote_pi.rpm(rpm)
-                dest = joinpath(content_dir, rpm['arch'])
-                rpmname = f"{rpm['nvr']}.{rpm['arch']}.rpm"
-            else:
-                # rpm is a relative path under the work/ directory
-                taskdir, rpmname = rpm.split('/')[-2:]
-                url = remote_pi.work() + '/' + rpm
-                dest = joinpath(content_dir, taskdir)
-            koji.ensuredir(dest)
-            filedest = joinpath(dest, rpmname)
-            self.requests_get(url, filedest)
+
+class TaskReposTask(koji.tasks.BaseTaskHandler):
+
+    Methods = ['taskrepos']
+    _taskWeight = 2.0
 
     def gen_repodata(self, rpmdir, baseurl):
+        koji.ensuredir(rpmdir)
         cmd = [
             '/usr/bin/createrepo_c',
             '--database',
+            '--baseurl=%s' % baseurl,
             '--checksum=sha256',
-            f'--baseurl={baseurl}',
             '--general-compress-type=gz',
             rpmdir,
         ]
-        self.logger.debug(f'Running: {" ".join(cmd)}')
+        self.logger.debug('Running: %s' % " ".join(cmd))
 
         proc = subprocess.run(cmd, cwd=rpmdir, capture_output=True)
         self.logger.debug(proc.stdout.decode())
@@ -99,21 +68,38 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
             self.logger.debug(proc.stderr.decode())
         proc.check_returncode()
 
+    def check_mergerepo_c(self):
+        cmd = ['/usr/bin/mergerepo_c', '--version']
+        try:
+            proc = subprocess.Popen(cmd, stdout=subprocess.PIPE)
+            out, _ = proc.communicate()
+            status = proc.wait()
+            if status != 0:
+                self.logger.warning("Unable to detect mergerepo_c version")
+                return False
+        except Exception:
+            self.logger.warning("Unable to detect mergerepo_c version")
+            return False
+        return True
+
     def merge_arch_repo(self, arch, repodir, srcdir):
         archdir = joinpath(repodir, arch)
-        self.logger.debug(f'Creating {arch} repo under {archdir}')
+        self.logger.debug('Creating %s repo under %s' % (arch, archdir))
         koji.ensuredir(archdir)
-        cmd = [
-            '/usr/bin/mergerepo_c',
-            '--koji',
-            '--database',
-            f'--outputdir={archdir}',
-            f'--archlist={arch},noarch,src',
-            '--compress-type=gz',
-        ]
+        if self.check_mergerepo_c:
+            cmd = [
+                '/usr/bin/mergerepo_c',
+                '--koji',
+                '--database',
+                '--outputdir=%s' % archdir,
+                '--archlist=%s,noarch,src' % arch,
+                '--compress-type=gz',
+            ]
+        else:
+            raise koji.GenericError("mergerepo_c is not installed")
         for srcrepo in os.listdir(srcdir):
-            cmd.append(f'--repo={srcrepo}')
-        self.logger.debug(f'Running: {" ".join(cmd)}')
+            cmd.append('--repo=%s' % srcrepo)
+        self.logger.debug('Running: %s' " ".join(cmd))
         proc = subprocess.run(cmd, cwd=srcdir, capture_output=True)
         self.logger.debug(proc.stdout.decode())
         if proc.stderr:
@@ -133,65 +119,44 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
     def create_repos(self, taskinfo):
         builds = self.session.listBuilds(taskID=taskinfo['id'])
         build = None
-        task_id = str(self.id)
         if builds:
-            build = builds[0]
-            rpms = self.session.listRPMs(buildID=build['build_id'])
-            repodir = joinpath(self.workdir, 'taskrepos', task_id, task_id,
-                               build['name'], build['version'], build['release'])
-            nvr = f"{build['name']}.{build['version']}.{build['release']}"
+            info = builds[0]
+            rpms = self.session.listRPMs(buildID=info['build_id'])
+            repotype = 'official'
         else:
-            children = self.session.getTaskChildren(taskinfo['id'], request=True)
-            srpminfo = None
+            info = None
             rpms = []
-            for child in children:
-                if child['method'] != 'buildArch':
-                    continue
-                results = self.session.getTaskResult(child['id'])
-                if results.get('srpms'):
-                    rpms.append(results['srpms'][0])
-                    srpmname = os.path.basename(results['srpms'][0])
-                    srpminfo = koji.parse_NVRA(srpmname)
-                rpms.extend(results['rpms'])
-            assert srpminfo, 'missing srpm'
-            repodir = joinpath(self.workdir, 'taskrepos', task_id, task_id, 'scratch',
-                               srpminfo['name'], srpminfo['version'], srpminfo['release'])
-            nvr = f"{srpminfo['name']}.{srpminfo['version']}.{srpminfo['release']}"
+            results = self.session.getTaskResult(taskinfo['id'])
+            if results.get('srpms'):
+                rpms.append(results['srpms'][0])
+                srpmname = os.path.basename(results['srpms'][0])
+                info = koji.parse_NVRA(srpmname)
+            rpms.extend(results['rpms'])
+            if info is None:
+                raise koji.GenericError("SRPM is missing.")
+            repotype = 'scratch'
+        repodir = joinpath(self.workdir, info['name'], info['version'], info['release'])
+        repodir_nvr = joinpath(repotype, info['name'], info['version'], info['release'])
+        nvr = '%s-%s-%s' % (info['name'], info['version'], info['release'])
+
         koji.ensuredir(repodir)
 
-        dirfd = os.open(repodir, os.O_RDONLY)
-        fcntl.flock(dirfd, fcntl.LOCK_EX)
-        self.rm_contents(repodir)
-        content_dir = joinpath(repodir, '_content')
-        self.mirror_rpms(rpms, content_dir, build=build)
         pi = koji.PathInfo(self.options.topurl)
-        for subdir in os.listdir(content_dir):
+        for arch in self.build_arches(rpms):
             if build:
-                baseurl = pi.build(build) + '/' + subdir
+                baseurl = pi.build(build) + '/' + arch
             else:
-                baseurl = pi.task(int(subdir))
-            self.gen_repodata(joinpath(content_dir, subdir), baseurl)
+                baseurl = pi.task(int(taskinfo['id']))
+            self.gen_repodata(joinpath(repodir, arch), baseurl)
         for arch in self.build_arches(rpms):
-            self.merge_arch_repo(arch, repodir, content_dir)
-        rmtree(content_dir)
-        return repodir, baseurl, nvr
-
-    def link_task_repos(self, task_id, repodir):
-        """Symlink repodir to $basedir/tasks/{task_id}"""
-        tasksdir = joinpath(self.workdir, 'tasks')
-        if not os.path.exists(tasksdir):
-            koji.ensuredir(tasksdir)
-        dstdir = joinpath(tasksdir, str(task_id))
-        if os.path.islink(dstdir) or os.path.isfile(dstdir):
-            os.remove(dstdir)
-        elif os.path.isdir(dstdir):
-            rmtree(dstdir)
-        os.symlink(os.path.relpath(repodir, tasksdir), dstdir)
-
-    def write_repo_file(self, task, repodir):
-        nvr = '-'.join(repodir.split('/')[-3:])
+            self.merge_arch_repo(arch, repodir, repodir)
+        return repodir, repodir_nvr, nvr, repotype
+
+    def write_repo_file(self, task, repodir, nvr, repotype):
         if len(task['request']) > 2:
-            scratch = task['request'][2].get('scratch', False)
+            for tr in task['request']:
+                if isinstance(tr, dict):
+                    scratch = tr.get('scratch', False)
         else:
             scratch = False
         subtasks = []
@@ -199,38 +164,42 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
             subtasks = [subtask for subtask in task.getChildren(task['id'], request=True)]
         repo_arches = []
         for subtask in subtasks:
-            repo_arches.append(f'{self.options.topurl}/{subtask["label"]}')
+            repo_arches.append('%s/%s' % (self.options.topurl, subtask["label"]))
+        rpminfo = koji.parse_NVR(nvr)
+        baseurl = joinpath(self.options.topurl, 'repos-tasks', repotype,
+                           rpminfo['name'], rpminfo['version'], rpminfo['release'])
         if 'noarch' in repo_arches:
-            repo_url = f'{self.options.topurl}/noarch/'
+            baseurl = '%s/noarch/' % baseurl
         else:
-            repo_url = f'{self.options.topurl}/$basearch/'
+            baseurl = '%s/%s/' % (baseurl, '$basearch')
         repo_file_name = nvr
-        repo_name = f'brew-task-repo-{nvr.replace('+', '_')}'
+        repo_name = 'brew-task-repo-%s' % nvr.replace('+', '_')
         build = 'build'
         if scratch:
             repo_file_name += '-scratch'
             repo_name += '-scratch'
             build = 'scratch build'
         repo_file_name += '.repo'
-        repo_file = f'{repodir}/{repo_file_name}'
+        repo_file = '%s/%s' % (repodir, repo_file_name)
 
         with koji._open_text_file(repo_file, 'w') as repo_fd:
             repo_fd.write(
-                f"""[{repo_name}]
-    name=Repo for Brew {build} of {nvr}
-    enabled=1
-    gpgcheck=0
-    baseurl={repo_url}
-    module_hotfixes=1
-    """
+                """[%s]
+name=Repo for Brew %s of %s
+enabled=1
+gpgcheck=0
+baseurl=%s
+module_hotfixes=1
+""" % (repo_name, build, nvr, baseurl)
             )
-        self.logger.debug(f'Wrote repo file to {repo_file}')
-        return repo_file_name
+        self.logger.debug('Wrote repo file to %s' % repo_file)
+        return baseurl
 
     def upload_repo(self, repodir):
         repo_files = []
-        repo_paths = []
-        uploadpath_basic = "taskrepos/%s/%s" % (self.id % 10000, self.id)
+        repos = []
+        repopath_part = '/'.join(repodir.split('/')[-4:])
+        uploadpath_basic = joinpath("repos-tasks", repopath_part)
         for dirpath, dirs, files in os.walk(repodir):
             relrepodir = os.path.relpath(dirpath, repodir)
             for filename in files:
@@ -247,11 +216,13 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
                     uploadpath = uploadpath_basic
                     fn = relpath
                 self.session.uploadWrapper(localpath, uploadpath, fn)
-                repo_paths.append(joinpath(uploadpath, filename))
+                repos.append([uploadpath, fn])
                 repo_files.append(relpath)
-        return uploadpath_basic, repo_files, repo_paths
+        return repo_files, repos, repopath_part
 
     def handler(self, task_id_child, task_link=False):
+        read_config()
+        data = {}
         if not isinstance(task_id_child, int):
             task_id_child = int(task_id_child)
         taskinfo = self.session.getTaskInfo(task_id_child, request=True)
@@ -260,96 +231,56 @@ class TaskReposTask(koji.tasks.BaseTaskHandler):
         }
         self.session.host.assertPolicy('taskrepos', policy_data)
         if not taskinfo:
-            raise koji.BuildError(f'Invalid task ID: {task_id_child}')
-        if taskinfo['method'] != 'build':
-            raise koji.BuildError(f'{task_id_child} is not a build task')
-        build_subtask = next(task for task in self.session.getTaskChildren(task_id_child)
-                             if task['method'] == 'buildArch')
-        if build_subtask['state'] != 2:
-            raise koji.BuildError(f'task {build_subtask['id']} has not completed successfully')
-        repodir, baseurl, nvr = self.create_repos(taskinfo)
-        self.logger.debug(f'Repos for task {task_id_child} created under {repodir}')
-        if task_link:
-            self.link_task_repos(task_id_child, repodir)
-        self.write_repo_file(taskinfo, repodir)
-        uploadpath, repo_files, repo_paths = self.upload_repo(repodir)
-        owner_id = taskinfo['owner']
-        owner = self.session.getUser(owner_id)['name']
-        self.session.tasksRepoNotifications(self.id, repodir, baseurl, owner, repo_paths, nvr)
+            raise koji.BuildError('Invalid task ID: %s' % task_id_child)
+        if taskinfo['method'] != 'buildArch':
+            raise koji.BuildError('%s is not a build task' % task_id_child)
+        if taskinfo['state'] != 2:
+            raise koji.BuildError('task %s has not completed successfully' % taskinfo['id'])
+        repodir, repodir_nvr, data['nvr'], repotype = self.create_repos(taskinfo)
+        self.logger.debug('Repos for task %s created under %s' % (task_id_child, repodir))
+        data['baseurl'] = self.write_repo_file(taskinfo, repodir, data['nvr'], repotype)
+        repo_files, repos, repopath_part = self.upload_repo(repodir)
+        data['owner'] = self.session.getUser(taskinfo['owner'])['name']
+        data['repo_urls'], uploadpath = self.session.taskRepoDone(
+            self.id, repos, repodir_nvr, self.options.topurl, task_link)
+        data['repodir'] = joinpath(koji.pathinfo.topdir, 'repos-tasks', repodir_nvr)
+        self.session.host.tasksRepoNotifications(self.id, data)
         return [uploadpath, repo_files]
 
 
 class tasksRepoNotifications(BaseTaskHandler):
     Methods = ['tasksRepoNotifications']
-
     _taskWeight = 0.1
+    INI_FILE = '/etc/kojid/plugins/taskrepos.ini'
+    ini_config = ''
 
-    def __init__(self, *args, **kwargs):
-        self._read_config()
-        return super(tasksRepoNotifications, self).__init__(*args, **kwargs)
-
-    def _read_config(self):
-        cp = koji.read_config_files(CONFIG_FILE)
-        self.config = {
-            'REPO_LIFETIME': 14,  # days
-            'TICKETLINK': '',
-            'SOURCECODE': '',
+    def read_ini_file(self):
+        cp_ini = koji.read_config_files(self.INI_FILE)
+        self.ini_config = {
+            'email_template': '',
         }
 
         # expire repos in days
-        if cp.has_option('taskrepos', 'expire_repos'):
-            self.config['REPO_LIFETIME'] = cp.get('taskrepos', 'expire_repos')
-
-        if cp.has_option('taskrepos', 'ticketlink'):
-            self.config['TICKETLINK'] = cp.get('taskrepos', 'ticketlink')
-
-        if cp.has_option('taskrepos', 'sourcecodelink'):
-            self.config['SOURCECODE'] = cp.get('taskrepos', 'sourcecodelink')
-
-    # XXX externalize these templates somewhere
-    subject_templ = 'repo for %(build)s of %(nvr)s is available'
-    message_templ = \
-        """From: "Brew Task Repos System" %(from_addr)s\r
-Subject: %(subject)s\r
-To: %(recipient)s\r
-A yum repository for the %(build)s of %(nvr)s (task %(task_id)s) is available at:\r
-\r
-%(repodir)s/\r
-\r
-You can install the rpms locally by putting this .repo file in your /etc/yum.repos.d/ directory:\r
-\r
-%(repofile)s\r
-\r
-It is necessary to have internal Red Hat CA certificates installed on the system, if
-you want to use yum repository. You can install required certificates from:\r
-\r
-* http://hdn.corp.redhat.com/rhel7-csb-stage/repoview/redhat-internal-cert-install.html (rpm)\r
-* https://certs.corp.redhat.com/ (cert files)\r
-\r
-The full list of repos is:\r
-%(repo_urls)s\r
-\r
-The repository will be available for the next %(repolifetime)s days.
-Scratch build output will be deleted earlier, based on the Brew scratch build retention policy.\r
-\r
-If you found a bug or you wish to stop these emails, please create a ticket:\r
-%(ticketlink)s\r
-\r
-Source code at %(sourcecode)s\r
-"""
-
-    def handler(self, recipient, repo_urls, task_id, repodir, repofile, nvr):
-        if len(recipient) == 0:
-            self.logger.debug(f'task {self.id}: no recipients, not sending notifications')
-            return
-        from_addr = self.options.from_addr
-        ticketlink = self.config['TICKETLINK']
-        sourcecode = self.config['SOURCECODE']
-        repolifetime = self.config['REPO_LIFETIME']
-        build = nvr.split('.')[0]
-        repo_urls = '\n'.join(repo_urls)
-        subject = self.subject_templ % locals()
-        message = self.message_templ % locals()
+        if cp_ini.has_option('EMAIL TEMPLATE', 'email_template'):
+            self.ini_config['email_template'] = cp_ini.get('EMAIL TEMPLATE', 'email_template')
+
+    def handler(self, recipient, data):
+        read_config()
+        self.read_ini_file()
+        data['from_addr'] = self.options.from_addr
+        repo_urls = data['repo_urls'].copy()
+        data['repo_urls'] = ''
+        for rf in repo_urls:
+            if '.repo' in rf:
+                data['repofile'] = rf
+            else:
+                data['repo_urls'] += '%s\n' % rf
+        data['ticketlink'] = config['ticketlink']
+        data['sourcecode'] = config['sourcecode']
+        data['repolifetime'] = config['repo_lifetime']
+        data['build'] = '-'.join(data['nvr'].split('-')[:-2])
+        data['recipient'] = recipient
+        message = config['email_template'] % data
 
         # ensure message is in UTF-8
         message = koji.fixEncoding(message)
@@ -360,7 +291,7 @@ Source code at %(sourcecode)s\r
         if self.options.smtp_user is not None and self.options.smtp_pass is not None:
             server.login(self.options.smtp_user, self.options.smtp_pass)
         # server.set_debuglevel(True)
-        server.sendmail(from_addr, recipient, message)
+        server.sendmail(data['from_addr'], recipient, message)
         server.quit()
 
-        return f'sent notification of taskrepo {self.id} to: {recipient}'
+        return 'sent notification of taskrepo %s to: %s' % (self.id, recipient)
diff --git a/plugins/hub/taskrepos_hub.py b/plugins/hub/taskrepos_hub.py
index 2832d46..a91cb16 100644
--- a/plugins/hub/taskrepos_hub.py
+++ b/plugins/hub/taskrepos_hub.py
@@ -4,38 +4,71 @@
 
 
 import kojihub
+import logging
+import os
+import shutil
 
+import koji
 from koji.context import context
-from koji.plugin import export, callback
-from koji.util import joinpath
+from koji.plugin import export, export_in, callback
+from koji.util import joinpath, safer_move, rmtree
 
-__all__ = ('taskrepos',)
+__all__ = ('taskrepos', 'tasksRepoNotifications', 'taskRepoDone')
 
 
-@callback('postBuildStateChange')
+logger = logging.getLogger('koji.hub')
+
+
+@export
+def taskRepoDone(task_id, repos, repodir_nvr, topurl, task_link):
+    repo_urls = []
+    nvr_dir = '/'.join(repodir_nvr.split('/')[1:]) + '/'
+    for rp, fn in repos:
+        src = joinpath(koji.pathinfo.work(), rp, fn).replace('/.', '/')
+        repostasks_dir = joinpath(koji.pathinfo.topdir, 'repos-tasks', repodir_nvr,
+                                  rp.split(nvr_dir)[1]).replace('/.', '/')
+        repostasks_file = joinpath(repostasks_dir, fn).replace('/.', '/')
+        koji.ensuredir(repostasks_dir)
+        if not os.path.exists(src):
+            raise koji.GenericError("uploaded file missing: %s" % src)
+        safer_move(src, repostasks_file)
+        repo_urls.append(joinpath(topurl, 'repos-tasks', repodir_nvr,
+                                  rp.split(nvr_dir)[1], fn).replace('/.', '/'))
+    if task_link:
+        repodir = joinpath(koji.pathinfo.topdir, 'repos-tasks', repodir_nvr)
+        task_dir_with_id = joinpath(koji.pathinfo.topdir, 'tasks', str(task_id % 10000))
+        koji.ensuredir(task_dir_with_id)
+        dstdir = joinpath(task_dir_with_id, str(task_id))
+        if os.path.islink(dstdir) or os.path.isfile(dstdir):
+            os.remove(dstdir)
+        elif os.path.isdir(dstdir):
+            rmtree(dstdir)
+        os.symlink(repodir, dstdir)
+    shutil.rmtree(joinpath(
+        koji.pathinfo.work(), '/'.join(rp.split(str(task_id))[:1]), str(task_id)))
+    return repo_urls, repostasks_dir
+
+
+@callback('postTaskStateChange')
 def taskrepos(cbtype, *args, **kws):
-    task_id = kws['info']['task_id']
+    if kws['attribute'] != 'state':
+        return
+    task_id = kws['info']['id']
     task = kojihub.Task(task_id)
-    subtasks_method = [subtask['method'] for subtask in task.getChildren(task_id)]
-    if 'buildArch' not in subtasks_method:
+    taskinfo = task.getInfo()
+    if taskinfo['method'] != 'buildArch' or taskinfo['state'] != koji.TASK_STATES['CLOSED']:
         return
-    task_link = False
+    task_link = True
 
     kojihub.make_task('taskrepos', [task_id, task_link])
-    return
 
 
-@export
-def tasksRepoNotifications(task_id, repodir, baseurl, owner, repo_paths, nvr):
+@export_in('host')
+def tasksRepoNotifications(task_id, data):
     if context.opts.get('DisableNotifications'):
         return
     email_domain = context.opts['EmailDomain']
-    email = f'{owner}@{email_domain}'
-    repo_urls = []
-    for rf in repo_paths:
-        if '.repo' in rf:
-            repofile = joinpath(baseurl, rf)
-        else:
-            repo_urls.append(joinpath(baseurl, rf))
-    kojihub.make_task('tasksRepoNotifications',
-                      [email, repo_urls, task_id, repodir, repofile, nvr])
+    email = f'{data['owner']}@{email_domain}'
+
+    data['task_id'] = task_id
+    kojihub.make_task('tasksRepoNotifications', [email, data])

